*******************************************************************************
*   File........: aelem3d.prg
*   Date........: September 30, 1993
*   Author......: Ly Minh Tr (CIS 70641,3127)
*   Copyright...: None...freeware!
*   Version.....: 1.02
*******************************************************************************
*   PURPOSE:    aelem3d() fetches the value of the element <i>, <j>, <k>
*               in the 3D-array <parray>.
*
*   SYNTAX:     aelem3d(<parray>, <i>, <j>, <k>)
*
*   PARAMETERS: <parray>    = the 3D-array to store data into
*               <i>         = subscript for dimension 1
*               <j>         = subscript for dimension 2
*               <k>         = subscript for dimension 3
*
*   RETURNS:    Data type of element at <i>, <j>, <k> in <parray>,
*               .F. if not a valid element of 3D-array.
*
*   SEE ALSO:   acount3d(), adel3d(), adim3d(), afill3d(), ains3d(), alen3d(),
*               aloc3d(), astore3d(), asubs3d()
*******************************************************************************
PARAMETER parray, i, j, k
PRIVATE nloc, lexp
EXTERNAL ARRAY parray

IF PARAMETER() <> 4
    WAIT WINDOW [Invalid number of parameters given!] TIMEOUT 1
    RETURN .F.
ENDIF

nloc = aloc3d(@parray, i, j, k)         && Get corresponding 1D-array subscript
IF nloc > 0
    lexp = parray[nloc]                 && Fetch data from parray[]
ELSE
    lexp = .F.
ENDIF

RETURN lexp
