set talk off
release all
clear all
clear

public b
dimension b[1]

if !adim3d(@b, 2,2,2)
    set talk on
    return
endif

= afill3d(@b, [hello world])            && Fill the whole array
display memory like b
?
= ar3d_show(@b)
= inkey(3)

= afill3d(@b, [hello], 1, 0)            && Fill first plane on x-axis
= afill3d(@b, [world], 2, 0)            && Fill second plane on x-axis
= ar3d_show(@b)
= inkey(3)

= astore3d(@b, 1,1,1, 1)                && store sequential values into array
= astore3d(@b, 1,1,2, 2)
= astore3d(@b, 1,2,1, 3)
= astore3d(@b, 1,2,2, 4)
= astore3d(@b, 2,1,1, 5)
= astore3d(@b, 2,1,2, 6)
= astore3d(@b, 2,2,1, 7)
= astore3d(@b, 2,2,2, 8)
= ar3d_show(@b)
= inkey(3)

= adim3d(@b, 2,2,3)                     && expand array by 1 width
= ar3d_show(@b)
= inkey(3)

= ains3d(@b, 1, 1)                      && insert 1st plane of y-axis
= ar3d_show(@b)
= inkey(3)

= adel3d(@b, 1, 1)                      && delete 1st plane of y-axis
= ar3d_show(@b)

= ar3d_view(@b)

= astore3d(@b, 2,2,1, .T.)
= astore3d(@b, 2,2,2, .T.)
= astore3d(@b, 2,2,3, .T.)
?
? [# of .T. values in array b = ], alltrim(STR(acount3d(@b, .T.)))
nloc = acount3d(@b, .T., 2)
? [The 2nd occurrence of .T. in array b is at location: ], alltrim(STR(nloc))
nrow = asubs3d(@b, nloc, 1)
ncol = asubs3d(@b, nloc, 2)
nwidth = asubs3d(@b, nloc, 3)
? [The row, column and width subscripts are: ], ;
	alltrim(STR(nrow)),[, ], alltrim(STR(ncol)),[, ], alltrim(STR(nwidth))

set talk on

return


procedure ar3d_show
    parameter parray
	private i, j, k, nrow, ncol, nwidth, nloc
    external array parray

    nrow    = INT(VAL(SUBSTR(parray[1], 4)))
    ncol    = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 2)+1)))
    nwidth  = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 3)+1)))

    for i = 1 to nrow
        for j = 1 to ncol
            for k = 1 to nwidth
                nloc = aloc3d(@parray, i, j, k)
                ? "parray[" + alltrim(str(i)) + "," + alltrim(str(j)) + ;
                  "," + alltrim(str(k)) + "] = ", parray[nloc]
            endfor
        endfor
    endfor
    ?
return


procedure ar3d_view
    parameter parray
	private i, j, k, nrow, ncol, nwidth, nloc, x, y, z
    external array parray

    nrow    = INT(VAL(SUBSTR(parray[1], 4)))
    ncol    = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 2)+1)))
    nwidth  = INT(VAL(SUBSTR(parray[1], AT(",", parray[1], 3)+1)))

	k = 1
    for i = 1 to nrow
        for j = 1 to ncol
            for k = 1 to nwidth
                nloc = aloc3d(@parray, i, j, k)

                x = asubs3d(@parray, nloc, 1)
                y = asubs3d(@parray, nloc, 2)
                z = asubs3d(@parray, nloc, 3)

                ? nloc-1, "X:", x, "   Y:", y, "   Z:", z
            endfor
        endfor
    endfor
    ?
return

procedure ar2d_view
    parameter parray
	private i, j, nrow, ncol, nloc, x, y
    external array parray

    nrow    = ALEN(parray, 1)
    ncol    = ALEN(parray, 2)

    for i = 1 to nrow
        for j = 1 to ncol
            nloc = aelement(parray, i, j)

            x = asubscript(parray, nloc, 1)
            y = asubscript(parray, nloc, 2)

        	? nloc, "X:", x, "   Y:", y
        endfor
    endfor
    ?
return
